=== debian/changelog ===
dhewm3 (1.5.1~pre+git20200905+dfsg-1) unstable; urgency=medium

  * New upstream version 1.5.1~pre+git20200905+dfsg
  * Bump compat level to 13 -- no changes.

 -- Tobias Frost <tobi@debian.org>  Mon, 05 Oct 2020 18:52:02 +0200
