## dhewm3 1.5.1+dfsg

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -71,17 +71,52 @@
 	set(cpu "ppc")
 elseif(cpu MATCHES "i.86")
 	set(cpu "x86")
-endif()
-
-if(MSVC AND CMAKE_CL_64)
-	set(cpu "amd64")
-endif()
+elseif(cpu MATCHES "[aA][mM][dD]64" OR cpu MATCHES "[xX]64")
+	set(cpu "x86_64")
+endif()
+
+# On Windows ${CMAKE_SYSTEM_PROCESSOR} is broken (always returns host CPU)
+# which has only been reported >7 years ago (https://cmake.org/pipermail/cmake-developers/2014-September/011405.html)
+# so obviously a fix is too much to ask. Here's the special case to make that wonderful platform work;
+# except if it's Windows for ARM(64) I guess, no idea how to detect that properly (I don't own such hardware).
+if(MSVC)
+	if(cpu MATCHES ".*[aA][rR][mM].*")
+		message(FATAL_ERROR "please fix this code to work for Windows on ARM and send a pull request")
+	endif()
+	if(CMAKE_CL_64)
+		set(cpu "x86_64")
+	else()
+		set(cpu "x86")
+	endif()
+elseif(DEFINED ENV{MINGW_CHOST})
+	# looks like it's broken in MinGW32 shells (or 32bit mingw-w64 shells) as well, this should help:
+	message(STATUS "MINGW_CHOST = $ENV{MINGW_CHOST}")
+	if($ENV{MINGW_CHOST} MATCHES "^i.86.*")
+		set(cpu "x86")
+	elseif($ENV{MINGW_CHOST} MATCHES "^x86_64.*")
+		set(cpu "x86_64")
+	else()
+		message(FATAL_ERROR "please fix this code to work for MINGW_CHOST = $ENV{MINGW_CHOST} and send a pull request!")
+	endif()
+endif()
+
+add_definitions(-DD3_ARCH="${cpu}" -DD3_SIZEOFPTR=${CMAKE_SIZEOF_VOID_P})
 
 # target os
 if(APPLE)
 	set(os "macosx")
 else()
 	string(TOLOWER "${CMAKE_SYSTEM_NAME}" os)
+endif()
+
+add_definitions(-DD3_OSTYPE="${os}")
+
+message(STATUS "Setting -DD3_ARCH=\"${cpu}\" -DD3_SIZEOFPTR=${CMAKE_SIZEOF_VOID_P} -DD3_OSTYPE=\"${os}\" ")
+
+if(cpu MATCHES ".*64.*" AND NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
+	# tough luck if some CPU architecture has "64" in its name but uses 32bit pointers
+	message(SEND_ERROR "CMake thinks sizeof(void*) == 4, but the target CPU looks like a 64bit CPU!")
+	message(FATAL_ERROR "If you're building in a 32bit chroot on a 64bit host, switch to it with 'linux32 chroot' or at least call cmake with linux32 (or your OSs equivalent)!")
 endif()
 
 # build type
@@ -220,6 +255,12 @@
 	if(cxx_has_Woverload_virtual)
 		add_compile_options(-Woverloaded-virtual)
 	endif()
+	
+	# shut up about using memcpy() on classes, in the cases doom3 uses it it seems to be fine
+	CHECK_CXX_COMPILER_FLAG("-Wno-class-memaccess" cxx_has_Wno-class-memaccess)
+	if(cxx_has_Wno-class-memaccess)
+		add_compile_options(-Wno-class-memaccess)
+	endif()
 
 	if(AROS)
 		set(CMAKE_SHARED_LIBRARY_SUFFIX ".aros-${cpu}")
@@ -230,6 +271,9 @@
 		if(cpu STREQUAL "x86_64")
 			add_compile_options(-arch x86_64 -mmacosx-version-min=10.9)
 			set(ldflags "${ldflags} -arch x86_64 -mmacosx-version-min=10.9")
+		elseif(cpu STREQUAL "arm64")
+			add_compile_options(-arch arm64 -mmacosx-version-min=11.0)
+			set(ldflags "${ldflags} -arch arm64 -mmacosx-version-min=11.0")
 		elseif(cpu STREQUAL "x86")
 			CHECK_CXX_COMPILER_FLAG("-arch i386" cxx_has_arch_i386)
 			if(cxx_has_arch_i386)
@@ -300,73 +344,3 @@
 		iphlpapi
 		wsock32
 		ole32
-	)
-endif()
-
-# fallback for cmake versions without GNUInstallDirs
-if(GNUINSTALLDIRS MATCHES "NOTFOUND")
-	set(CMAKE_INSTALL_BINDIR		"bin"
-		CACHE PATH "user executables (bin)")
-	set(CMAKE_INSTALL_LIBDIR		"lib${LIB_SUFFIX}"
-		CACHE PATH "object code libraries (lib${LIB_SUFFIX})")
-	set(CMAKE_INSTALL_DATAROOTDIR	"share"
-		CACHE PATH "read-only architecture-independent data root (share)")
-	set(CMAKE_INSTALL_DATADIR		"${CMAKE_INSTALL_DATAROOTDIR}"
-		CACHE PATH "read-only architecture-independent data (DATAROOTDIR)")
-
-	mark_as_advanced(CMAKE_INSTALL_BINDIR CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_DATAROOTDIR CMAKE_INSTALL_DATADIR)
-	foreach(dir BINDIR LIBDIR DATAROOTDIR DATADIR)
-		if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_${dir}})
-			set(CMAKE_INSTALL_FULL_${dir} "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_${dir}}")
-		else()
-			set(CMAKE_INSTALL_FULL_${dir} "${CMAKE_INSTALL_${dir}}")
-		endif()
-	endforeach()
-endif()
-
-set(bindir		"${CMAKE_INSTALL_FULL_BINDIR}")
-set(libdir		"${CMAKE_INSTALL_FULL_LIBDIR}/dhewm3")
-set(datadir		"${CMAKE_INSTALL_FULL_DATADIR}/dhewm3")
-
-configure_file(
-	"${CMAKE_SOURCE_DIR}/config.h.in"
-	"${CMAKE_BINARY_DIR}/config.h"
-)
-
-message(STATUS "Building ${CMAKE_BUILD_TYPE} for ${os}-${cpu}")
-
-if(NOT APPLE AND NOT WIN32)
-	message(STATUS "The install target will use the following directories:")
-	message(STATUS "  Binary directory:  ${bindir}")
-	message(STATUS "  Library directory: ${libdir}")
-	message(STATUS "  Data directory:    ${datadir}")
-endif()
-
-set(src_renderer
-	renderer/Cinematic.cpp
-	renderer/GuiModel.cpp
-	renderer/Image_files.cpp
-	renderer/Image_init.cpp
-	renderer/Image_load.cpp
-	renderer/Image_process.cpp
-	renderer/Image_program.cpp
-	renderer/Interaction.cpp
-	renderer/Material.cpp
-	renderer/MegaTexture.cpp
-	renderer/Model.cpp
-	renderer/ModelDecal.cpp
-	renderer/ModelManager.cpp
-	renderer/ModelOverlay.cpp
-	renderer/Model_beam.cpp
-	renderer/Model_ase.cpp
-	renderer/Model_liquid.cpp
-	renderer/Model_lwo.cpp
-	renderer/Model_ma.cpp
-	renderer/Model_md3.cpp
-	renderer/Model_md5.cpp
-	renderer/Model_prt.cpp
-	renderer/Model_sprite.cpp
-	renderer/RenderEntity.cpp
-	renderer/RenderSystem.cpp
-	renderer/RenderSystem_init.cpp
-	renderer/RenderWorld.cpp
