=== debian/changelog ===
dhewm3 (1.5.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update d/watch to follow releases, not git commits.
  * Update years in d/copyright.
  * Bump S-V to 4.6.0 -- no changes.

 -- Tobias Frost <tobi@debian.org>  Wed, 10 Nov 2021 17:08:54 +0100
