=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libopenal-dev,
                libsdl2-dev (>= 2.0.4),
                libvorbis-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://dhewm3.org/
 Vcs-Browser: https://salsa.debian.org/games-team/dhewm3
 Vcs-Git: https://salsa.debian.org/games-team/dhewm3.git
