=== debian/changelog ===
dhewm3 (1.5.2+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:45:03 +1100

dhewm3 (1.5.2+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:48:59 +0000

dhewm3 (1.5.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update d/copyright.
  * Drop B-D on some libraries (libvorbis, libogg and libjpeg)
  * Update lintian overrides.
  * Bump S-V to 4.6.1 -- no changes required.

 -- Tobias Frost <tobi@debian.org>  Sat, 27 Aug 2022 11:42:28 +0200
