=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: dhewm3
 Section: contrib/games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Tobias Frost <tobi@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libcurl4-gnutls-dev,
-               libjpeg-dev,
-               libogg-dev,
                libopenal-dev,
                libsdl2-dev (>= 2.0.4),
-               libvorbis-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://dhewm3.org/
 Vcs-Browser: https://salsa.debian.org/games-team/dhewm3
 Vcs-Git: https://salsa.debian.org/games-team/dhewm3.git
