## dhewm3 1.5.4%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: dhewm3
 Section: contrib/games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Tobias Frost <tobi@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libcurl4-gnutls-dev,
                libopenal-dev,
-               libsdl2-dev (>= 2.0.4),
+               libsdl2-dev,
 Standards-Version: 4.6.1
 Homepage: https://dhewm3.org/
 Vcs-Browser: https://salsa.debian.org/games-team/dhewm3
@@ -21,7 +20,7 @@
 Depends: dhewm3 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: doom3-data | game-data-packager (>=40)
+Recommends: doom3-data | game-data-packager
 Description: dhewm3's gamelibrary for the title DOOM³
  This package contains the shared library containing the game logic for DOOM³
  .
@@ -37,7 +36,7 @@
 Depends: dhewm3-doom3 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: doom3-resurrection-data | game-data-packager (>=40)
+Recommends: doom3-resurrection-data | game-data-packager
 Description: dhewm3's gamelibrary for the title DOOM³: Resurrection of Evil
  This package contains the shared library containing the game logic for
  the add-on DOOM3³: Resurrection of Evil
