=== debian/changelog ===
dhewm3 (1.5.4+dfsg-1) unstable; urgency=medium

  [ Tobias Frost ]
  * New upstream release. (Closes: #1100435)
  * Refresh patches.
  * Build with imgui disabled, to avoid embedded code copy.
    - Remove embedded code copy of imgui when creating the orig.tar.
    - Apply fix to avoid FTBFS when imgui is turned off.
  * d/copyright: Document new sources' copyright and bump years.
  * New patch to avoid FTBFS on 32bit, cherry-picked from upstream.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on libsdl2-dev.
    + dhewm3-doom3: Drop versioned constraint on game-data-packager in
      Recommends.
    + dhewm3-d3xp: Drop versioned constraint on game-data-packager in
      Recommends.

 -- Tobias Frost <tobi@debian.org>  Sat, 22 Mar 2025 17:29:47 +0100
