=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,8 @@
 	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DSDL2=ON \
 	-DCMAKE_INSTALL_BINDIR="games" -DCMAKE_INSTALL_DATADIR="share/games" \
 	-DCMAKE_BUILD_TYPE=Debian \
-	-DREPRODUCIBLE_BUILD=On
+	-DREPRODUCIBLE_BUILD=On \
+	-DIMGUI=Off
 
 override_dh_installdocs:
 	dh_installdocs -A debian/license-assessment
