=== debian/watch ===
version=4

opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/dhewm3-$1\.tar\.gz/, dversionmangle=s/\+dfsg\d*$//, uversionmangle=s/_RC/~rc/; s/_PRE/~pre/, compression=xz, repacksuffix=+dfsg" \
  https://github.com/dhewm/dhewm3/tags .*/v?(\d\S+)\.tar\.gz

# kept for reference, when we start packaging snapshots again
#opts="mode=git, pgpmode=none, pretty=1.5.2~pre+git%cd+dfsg, dversionmangle=s/\+dfsg\d*$//" \
#https://github.com/dhewm/dhewm3.git \
#HEAD debian uupdate
